unit UnZLBArchive;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmZLBArchive = class(TForm)
    Label1: TLabel;
    btnDescompactar: TButton;
    btnCompactar: TButton;
    OpenDialog1: TOpenDialog;
    procedure btnCompactarClick(Sender: TObject);
    procedure btnDescompactarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmZLBArchive: TfrmZLBArchive;

implementation

uses ZLIBArchive;

{$R *.dfm}

procedure TfrmZLBArchive.btnCompactarClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if not OpenDialog1.Execute then Exit;

  with TZLBArchive.Create(nil) do
  try
    try
      ForceDirectories(ExtractFilePath(OpenDialog1.FileName));
      CompressionLevel := fcMaximum;
      CreateArchive(ChangeFileExt(OpenDialog1.FileName, '.zip'));
      AddFile(OpenDialog1.FileName);
    except
      on E: Exception do
        raise Exception.Create('No foi possvel compactar o arquivo.'#13'Erro: ' + E.Message);
    end;
  finally
    Free;
  end;
  if not FileExists(OpenDialog1.FileName) then
    raise Exception.Create('No foi possvel compactar o arquivo.'#13'Problema interno do componente ZLBArchive, de terceiros.');
end;

procedure TfrmZLBArchive.btnDescompactarClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if not OpenDialog1.Execute then Exit;

  with TZLBArchive.Create(nil) do
  try
    try
      OpenArchive(OpenDialog1.FileName);
      ExtractAll(ExtractFilePath(OpenDialog1.FileName));
    except
      on E: Exception do
        raise Exception.Create('No foi possvel descompactar o arquivo.'#13'Erro: ' + E.Message);
    end;
  finally
    Free;
  end;
end;

end.
